#include <bits/stdc++.h>
using namespace std;
int dec(int &a)
{
    if(a==0)
        return 0;
    else{
    int k=a%2;
    a/=2;
    return k;}
}
int main()
{

    int n,ans;
    int q,t,k,x;
    vector<int>a(n);
    vector<int>b(32,0),c(32);
    c[0]=1;
    for(int i=1;i<32;i++)
    {
        c[i]=2*c[i-1];
    }
    cin>>n;

    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        for(int j=0;j<32;j++)
        {
         if(dec(a[i]))b[j]++;
        }
    }
    cin>>q;
    while(q--)
    {
        cin>>t;
        if(t==0)
        {
            ans=0;
            cin>>k;
            for(int i=0;i<32;i++)
            {
                if(b[i]>=k)
                    ans+=b[i]*c[i];
            }
            cout<<ans;
        }
        if(t==1)
        {
            cin>>k>>x;
            for(int i=0;i<32;i++)
            {
                if(dec(a[k-1]) and !dec(x))b[i]--;
                if(!dec(a[k-1]) and dec(x))b[i]++;
            }
        }
    }
    return 0;
}